/* Scale.c generated by valac 0.56.17, the Vala compiler
 * generated from Scale.vala, do not modify */

/*
* Copyright 2015-2021 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "sound.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_WIDGETS_SCALE_0_PROPERTY,
	SOUND_WIDGETS_SCALE_ICON_PROPERTY,
	SOUND_WIDGETS_SCALE_ACTIVE_PROPERTY,
	SOUND_WIDGETS_SCALE_MAX_PROPERTY,
	SOUND_WIDGETS_SCALE_MIN_PROPERTY,
	SOUND_WIDGETS_SCALE_STEP_PROPERTY,
	SOUND_WIDGETS_SCALE_SCALE_WIDGET_PROPERTY,
	SOUND_WIDGETS_SCALE_SWITCH_WIDGET_PROPERTY,
	SOUND_WIDGETS_SCALE_NUM_PROPERTIES
};
static GParamSpec* sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SoundWidgetsScalePrivate {
	gchar* _icon;
	gboolean _active;
	gdouble _max;
	gdouble _min;
	gdouble _step;
	GtkScale* _scale_widget;
	GtkSwitch* _switch_widget;
};

static gint SoundWidgetsScale_private_offset;
static gpointer sound_widgets_scale_parent_class = NULL;

static void sound_widgets_scale_set_scale_widget (SoundWidgetsScale* self,
                                           GtkScale* value);
static void sound_widgets_scale_set_switch_widget (SoundWidgetsScale* self,
                                            GtkSwitch* value);
static GObject * sound_widgets_scale_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static gboolean _sound_widgets_scale___lambda41_ (SoundWidgetsScale* self);
static gboolean __sound_widgets_scale___lambda41__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                            GdkEventButton* event,
                                                                            gpointer self);
static gboolean _sound_widgets_scale___lambda42_ (SoundWidgetsScale* self,
                                           GdkEventScroll* e);
static gboolean __sound_widgets_scale___lambda42__gtk_widget_scroll_event (GtkWidget* _sender,
                                                                    GdkEventScroll* event,
                                                                    gpointer self);
static gboolean _sound_widgets_scale___lambda43_ (SoundWidgetsScale* self);
static gboolean __sound_widgets_scale___lambda43__gbinding_transform_func (GBinding* binding,
                                                                    GValue* from_value,
                                                                    GValue* to_value,
                                                                    gpointer self);
static void sound_widgets_scale_finalize (GObject * obj);
static GType sound_widgets_scale_get_type_once (void);
static void _vala_sound_widgets_scale_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_sound_widgets_scale_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
sound_widgets_scale_get_instance_private (SoundWidgetsScale* self)
{
	return G_STRUCT_MEMBER_P (self, SoundWidgetsScale_private_offset);
}

SoundWidgetsScale*
sound_widgets_scale_construct (GType object_type,
                               const gchar* icon,
                               gboolean active,
                               gdouble min,
                               gdouble max,
                               gdouble step)
{
	SoundWidgetsScale * self = NULL;
	g_return_val_if_fail (icon != NULL, NULL);
	self = (SoundWidgetsScale*) g_object_new (object_type, "active", active, "icon", icon, "max", max, "min", min, "step", step, NULL);
	return self;
}

SoundWidgetsScale*
sound_widgets_scale_new (const gchar* icon,
                         gboolean active,
                         gdouble min,
                         gdouble max,
                         gdouble step)
{
	return sound_widgets_scale_construct (SOUND_WIDGETS_TYPE_SCALE, icon, active, min, max, step);
}

const gchar*
sound_widgets_scale_get_icon (SoundWidgetsScale* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}

void
sound_widgets_scale_set_icon (SoundWidgetsScale* self,
                              const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_icon (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_icon);
		self->priv->_icon = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_ICON_PROPERTY]);
	}
}

gboolean
sound_widgets_scale_get_active (SoundWidgetsScale* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_active;
	return result;
}

void
sound_widgets_scale_set_active (SoundWidgetsScale* self,
                                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_active (self);
	if (old_value != value) {
		self->priv->_active = value;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_ACTIVE_PROPERTY]);
	}
}

gdouble
sound_widgets_scale_get_max (SoundWidgetsScale* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_max;
	return result;
}

static void
sound_widgets_scale_set_max (SoundWidgetsScale* self,
                             gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_max (self);
	if (old_value != value) {
		self->priv->_max = value;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_MAX_PROPERTY]);
	}
}

gdouble
sound_widgets_scale_get_min (SoundWidgetsScale* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_min;
	return result;
}

static void
sound_widgets_scale_set_min (SoundWidgetsScale* self,
                             gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_min (self);
	if (old_value != value) {
		self->priv->_min = value;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_MIN_PROPERTY]);
	}
}

gdouble
sound_widgets_scale_get_step (SoundWidgetsScale* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_step;
	return result;
}

static void
sound_widgets_scale_set_step (SoundWidgetsScale* self,
                              gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_step (self);
	if (old_value != value) {
		self->priv->_step = value;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_STEP_PROPERTY]);
	}
}

GtkScale*
sound_widgets_scale_get_scale_widget (SoundWidgetsScale* self)
{
	GtkScale* result;
	GtkScale* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scale_widget;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
sound_widgets_scale_set_scale_widget (SoundWidgetsScale* self,
                                      GtkScale* value)
{
	GtkScale* old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_scale_widget (self);
	if (old_value != value) {
		GtkScale* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_scale_widget);
		self->priv->_scale_widget = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_SCALE_WIDGET_PROPERTY]);
	}
}

GtkSwitch*
sound_widgets_scale_get_switch_widget (SoundWidgetsScale* self)
{
	GtkSwitch* result;
	GtkSwitch* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_switch_widget;
	result = _tmp0_;
	return result;
}

static void
sound_widgets_scale_set_switch_widget (SoundWidgetsScale* self,
                                       GtkSwitch* value)
{
	GtkSwitch* old_value;
	g_return_if_fail (self != NULL);
	old_value = sound_widgets_scale_get_switch_widget (self);
	if (old_value != value) {
		GtkSwitch* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_switch_widget);
		self->priv->_switch_widget = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_SWITCH_WIDGET_PROPERTY]);
	}
}

static gboolean
_sound_widgets_scale___lambda41_ (SoundWidgetsScale* self)
{
	GtkSwitch* _tmp0_;
	gboolean result;
	_tmp0_ = self->priv->_switch_widget;
	g_signal_emit_by_name (_tmp0_, "activate");
	result = GDK_EVENT_STOP;
	return result;
}

static gboolean
__sound_widgets_scale___lambda41__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                   GdkEventButton* event,
                                                                   gpointer self)
{
	gboolean result;
	result = _sound_widgets_scale___lambda41_ ((SoundWidgetsScale*) self);
	return result;
}

static gboolean
_sound_widgets_scale___lambda42_ (SoundWidgetsScale* self,
                                  GdkEventScroll* e)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (e != NULL, FALSE);
	g_signal_emit_by_name ((GtkWidget*) self, "scroll-event", e, &_tmp0_);
	result = GDK_EVENT_STOP;
	return result;
}

static gboolean
__sound_widgets_scale___lambda42__gtk_widget_scroll_event (GtkWidget* _sender,
                                                           GdkEventScroll* event,
                                                           gpointer self)
{
	gboolean result;
	result = _sound_widgets_scale___lambda42_ ((SoundWidgetsScale*) self, event);
	return result;
}

static gboolean
_sound_widgets_scale___lambda43_ (SoundWidgetsScale* self)
{
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	_tmp0_ = self->priv->_switch_widget;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_active;
	if (_tmp2_ != _tmp3_) {
		GtkSwitch* _tmp4_;
		_tmp4_ = self->priv->_switch_widget;
		g_signal_emit_by_name (_tmp4_, "activate");
	}
}

static gboolean
__sound_widgets_scale___lambda43__gbinding_transform_func (GBinding* binding,
                                                           GValue* from_value,
                                                           GValue* to_value,
                                                           gpointer self)
{
	gboolean result;
	result = _sound_widgets_scale___lambda43_ ((SoundWidgetsScale*) self);
	return result;
}

static GObject *
sound_widgets_scale_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundWidgetsScale * self;
	GtkImage* image = NULL;
	const gchar* _tmp0_;
	GtkImage* _tmp1_ = NULL;
	GtkEventBox* image_box = NULL;
	GtkEventBox* _tmp2_;
	GtkEventBox* _tmp3_;
	GtkImage* _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	GtkScale* _tmp8_ = NULL;
	GtkScale* _tmp9_;
	GtkSwitch* _tmp10_ = NULL;
	GtkSwitch* _tmp11_;
	GtkBox* box = NULL;
	GtkBox* _tmp12_ = NULL;
	GtkBox* _tmp13_;
	GtkEventBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkScale* _tmp16_;
	GtkBox* _tmp17_;
	GtkSwitch* _tmp18_;
	GtkBox* _tmp19_;
	GtkEventBox* _tmp20_;
	GtkEventBox* _tmp21_;
	GtkScale* _tmp22_;
	GtkImage* _tmp23_;
	GtkScale* _tmp24_;
	GtkImage* _tmp25_;
	GtkSwitch* _tmp26_;
	parent_class = G_OBJECT_CLASS (sound_widgets_scale_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_SCALE, SoundWidgetsScale);
	_tmp0_ = self->priv->_icon;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
	gtk_image_set_pixel_size (_tmp1_, 48);
	g_object_ref_sink (_tmp1_);
	image = _tmp1_;
	_tmp2_ = (GtkEventBox*) gtk_event_box_new ();
	g_object_ref_sink (_tmp2_);
	image_box = _tmp2_;
	_tmp3_ = image_box;
	_tmp4_ = image;
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
	_tmp5_ = self->priv->_min;
	_tmp6_ = self->priv->_max;
	_tmp7_ = self->priv->_step;
	_tmp8_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, _tmp5_, _tmp6_, _tmp7_);
	gtk_scale_set_draw_value (_tmp8_, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
	g_object_set ((GtkWidget*) _tmp8_, "width-request", 175, NULL);
	g_object_ref_sink (_tmp8_);
	_tmp9_ = _tmp8_;
	sound_widgets_scale_set_scale_widget (self, _tmp9_);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_margin_start ((GtkWidget*) _tmp10_, 6);
	gtk_widget_set_valign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	sound_widgets_scale_set_switch_widget (self, _tmp11_);
	_g_object_unref0 (_tmp11_);
	_tmp12_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp12_, 6);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp12_, 12);
	g_object_ref_sink (_tmp12_);
	box = _tmp12_;
	_tmp13_ = box;
	_tmp14_ = image_box;
	gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = box;
	_tmp16_ = self->priv->_scale_widget;
	gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = box;
	_tmp18_ = self->priv->_switch_widget;
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp19_);
	gtk_widget_add_events ((GtkWidget*) self, (gint) GDK_SMOOTH_SCROLL_MASK);
	gtk_event_box_set_above_child ((GtkEventBox*) self, FALSE);
	_tmp20_ = image_box;
	gtk_widget_add_events ((GtkWidget*) _tmp20_, (gint) GDK_BUTTON_RELEASE_MASK);
	_tmp21_ = image_box;
	g_signal_connect_object ((GtkWidget*) _tmp21_, "button-release-event", (GCallback) __sound_widgets_scale___lambda41__gtk_widget_button_release_event, self, 0);
	_tmp22_ = self->priv->_scale_widget;
	g_signal_connect_object ((GtkWidget*) _tmp22_, "scroll-event", (GCallback) __sound_widgets_scale___lambda42__gtk_widget_scroll_event, self, 0);
	_tmp23_ = image;
	g_object_bind_property_with_closures ((GObject*) self, "icon", (GObject*) _tmp23_, "icon-name", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp24_ = self->priv->_scale_widget;
	g_object_bind_property_with_closures ((GObject*) self, "active", (GObject*) _tmp24_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp25_ = image;
	g_object_bind_property_with_closures ((GObject*) self, "active", (GObject*) _tmp25_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp26_ = self->priv->_switch_widget;
	g_object_bind_property_with_closures ((GObject*) self, "active", (GObject*) _tmp26_, "active", G_BINDING_BIDIRECTIONAL, (GClosure*) ((__sound_widgets_scale___lambda43__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __sound_widgets_scale___lambda43__gbinding_transform_func, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_g_object_unref0 (box);
	_g_object_unref0 (image_box);
	_g_object_unref0 (image);
	return obj;
}

static void
sound_widgets_scale_base_init (SoundWidgetsScaleClass * klass)
{
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), GTK_STYLE_CLASS_MENUITEM);
}

static void
sound_widgets_scale_class_init (SoundWidgetsScaleClass * klass,
                                gpointer klass_data)
{
	sound_widgets_scale_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundWidgetsScale_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_widgets_scale_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_widgets_scale_set_property;
	G_OBJECT_CLASS (klass)->constructor = sound_widgets_scale_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_widgets_scale_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_ICON_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_ACTIVE_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_MAX_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_MAX_PROPERTY] = g_param_spec_double ("max", "max", "max", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_MIN_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_MIN_PROPERTY] = g_param_spec_double ("min", "min", "min", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_STEP_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_STEP_PROPERTY] = g_param_spec_double ("step", "step", "step", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_SCALE_WIDGET_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_SCALE_WIDGET_PROPERTY] = g_param_spec_object ("scale-widget", "scale-widget", "scale-widget", gtk_scale_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_WIDGETS_SCALE_SWITCH_WIDGET_PROPERTY, sound_widgets_scale_properties[SOUND_WIDGETS_SCALE_SWITCH_WIDGET_PROPERTY] = g_param_spec_object ("switch-widget", "switch-widget", "switch-widget", gtk_switch_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
sound_widgets_scale_instance_init (SoundWidgetsScale * self,
                                   gpointer klass)
{
	self->priv = sound_widgets_scale_get_instance_private (self);
}

static void
sound_widgets_scale_finalize (GObject * obj)
{
	SoundWidgetsScale * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_WIDGETS_TYPE_SCALE, SoundWidgetsScale);
	_g_free0 (self->priv->_icon);
	_g_object_unref0 (self->priv->_scale_widget);
	_g_object_unref0 (self->priv->_switch_widget);
	G_OBJECT_CLASS (sound_widgets_scale_parent_class)->finalize (obj);
}

static GType
sound_widgets_scale_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundWidgetsScaleClass), (GBaseInitFunc) sound_widgets_scale_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_widgets_scale_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundWidgetsScale), 0, (GInstanceInitFunc) sound_widgets_scale_instance_init, NULL };
	GType sound_widgets_scale_type_id;
	sound_widgets_scale_type_id = g_type_register_static (gtk_event_box_get_type (), "SoundWidgetsScale", &g_define_type_info, 0);
	SoundWidgetsScale_private_offset = g_type_add_instance_private (sound_widgets_scale_type_id, sizeof (SoundWidgetsScalePrivate));
	return sound_widgets_scale_type_id;
}

GType
sound_widgets_scale_get_type (void)
{
	static volatile gsize sound_widgets_scale_type_id__once = 0;
	if (g_once_init_enter (&sound_widgets_scale_type_id__once)) {
		GType sound_widgets_scale_type_id;
		sound_widgets_scale_type_id = sound_widgets_scale_get_type_once ();
		g_once_init_leave (&sound_widgets_scale_type_id__once, sound_widgets_scale_type_id);
	}
	return sound_widgets_scale_type_id__once;
}

static void
_vala_sound_widgets_scale_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SoundWidgetsScale * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_WIDGETS_TYPE_SCALE, SoundWidgetsScale);
	switch (property_id) {
		case SOUND_WIDGETS_SCALE_ICON_PROPERTY:
		g_value_set_string (value, sound_widgets_scale_get_icon (self));
		break;
		case SOUND_WIDGETS_SCALE_ACTIVE_PROPERTY:
		g_value_set_boolean (value, sound_widgets_scale_get_active (self));
		break;
		case SOUND_WIDGETS_SCALE_MAX_PROPERTY:
		g_value_set_double (value, sound_widgets_scale_get_max (self));
		break;
		case SOUND_WIDGETS_SCALE_MIN_PROPERTY:
		g_value_set_double (value, sound_widgets_scale_get_min (self));
		break;
		case SOUND_WIDGETS_SCALE_STEP_PROPERTY:
		g_value_set_double (value, sound_widgets_scale_get_step (self));
		break;
		case SOUND_WIDGETS_SCALE_SCALE_WIDGET_PROPERTY:
		g_value_set_object (value, sound_widgets_scale_get_scale_widget (self));
		break;
		case SOUND_WIDGETS_SCALE_SWITCH_WIDGET_PROPERTY:
		g_value_set_object (value, sound_widgets_scale_get_switch_widget (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sound_widgets_scale_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SoundWidgetsScale * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_WIDGETS_TYPE_SCALE, SoundWidgetsScale);
	switch (property_id) {
		case SOUND_WIDGETS_SCALE_ICON_PROPERTY:
		sound_widgets_scale_set_icon (self, g_value_get_string (value));
		break;
		case SOUND_WIDGETS_SCALE_ACTIVE_PROPERTY:
		sound_widgets_scale_set_active (self, g_value_get_boolean (value));
		break;
		case SOUND_WIDGETS_SCALE_MAX_PROPERTY:
		sound_widgets_scale_set_max (self, g_value_get_double (value));
		break;
		case SOUND_WIDGETS_SCALE_MIN_PROPERTY:
		sound_widgets_scale_set_min (self, g_value_get_double (value));
		break;
		case SOUND_WIDGETS_SCALE_STEP_PROPERTY:
		sound_widgets_scale_set_step (self, g_value_get_double (value));
		break;
		case SOUND_WIDGETS_SCALE_SCALE_WIDGET_PROPERTY:
		sound_widgets_scale_set_scale_widget (self, g_value_get_object (value));
		break;
		case SOUND_WIDGETS_SCALE_SWITCH_WIDGET_PROPERTY:
		sound_widgets_scale_set_switch_widget (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

